unit ottdimage;

interface

uses
  SysUtils, Classes, Controls, ExtCtrls;

type
  TOTTDImage = class(TImage)
  private
    { Private declarations }
    F_sprite_name:string;
    F_sprite_path:string;
    F_x_offs:integer;
    F_y_offs:integer;
    F_pos_x:integer;
    F_pos_y:integer;
    procedure SetOffsetX(offset:integer);
    procedure SetOffsetY(offset:integer);
    procedure SetSpriteName(name:string);
    procedure SetSpritePath(path:string);
    procedure SetPositionX(value:integer);
    procedure SetPositionY(value:integer);
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
  published
    { Published declarations }
    property SpriteName:string read F_sprite_name write SetSpriteName;
    property SpritePath:string read F_sprite_path write SetSpritePath;
    property SpriteOffsetX:integer read F_x_offs write SetOffsetX default 0;
    property SpriteOffsetY:integer read F_y_offs write SetOffsetY default 0;
    property SpriteLocationX:integer read F_pos_x write SetPositionX;
    property SpriteLocationY:integer read F_pos_y write SetPositionY;
  end;

procedure Register;

implementation

procedure TOTTDImage.SetOffsetX(offset: Integer);
begin
  if F_x_offs <> offset then F_x_offs := offset;
end;

procedure TOTTDImage.SetOffsetY(offset: Integer);
begin
  if F_y_offs <> offset then F_y_offs := offset;
end;

procedure TOTTDImage.SetSpriteName(name: string);
begin
  if F_sprite_name <> name then F_sprite_name := name;
end;

procedure TOTTDImage.SetSpritePath(path: string);
begin
  if F_sprite_path <> path then F_sprite_path := path;
end;

procedure TOTTDImage.SetPositionX(value: Integer);
begin
  if F_pos_x <> value then F_pos_x := value;
end;

procedure TOTTDImage.SetPositionY(value: Integer);
begin
  if F_pos_y <> value then F_pos_y := value;
end;

constructor TOTTDImage.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  F_x_offs := 0;
  F_y_offs := 0;
  F_pos_x  := 0;
  F_pos_y  := 0;
  F_sprite_name := '';
  F_sprite_path := '';
end;


procedure Register;
begin
  RegisterComponents('OpenTTD', [TOTTDImage]);
end;

end.
